| The Gaudi Framework v29r0 (ff2e7097)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
Gaudi::Property< DataObjIDColl > Class Template Reference

`#include <GaudiKernel/DataObjIDProperty.h>`

Inheritance diagram for Gaudi::Property< DataObjIDColl >:
[legend]
Collaboration diagram for Gaudi::Property< DataObjIDColl >:
[legend]

## Public Member Functions
| Property (const std::string &name, DataObjIDColl &value)
template<class OWNER >
| Property (OWNER *owner, const std::string &name, const DataObjIDColl &initval=DataObjIDColl{}, std::string doc="")
| Autodeclaring constructor with property name, value and documentation. More...
| operator const DataObjIDColl & () const
virtual | ~Property ()
| virtual Destructor More...
Public Member Functions inherited from DataObjIDCollProperty
| DataObjIDCollProperty (const std::string &name, DataObjIDColl &ref)
DataObjIDCollProperty & | operator= (const DataObjIDColl &value)
virtual | ~DataObjIDCollProperty ()
DataObjIDCollProperty * | clone () const override
| clones the current property More...
bool | load (Property &destination) const override
bool | assign (const Property &source) override
std::string | toString () const override
| value -> string More...
void | toStream (std::ostream &out) const override
| value -> stream More...
StatusCode | fromString (const std::string &s) override
| string -> value More...
const DataObjIDColl & | value () const
bool | setValue (const DataObjIDColl &value)
Public Member Functions inherited from PropertyWithHandlers<>
PropertyBase & | declareReadHandler (std::function< void(PropertyBase &)> fun) override
| set new callback for reading More...
PropertyBase & | declareUpdateHandler (std::function< void(PropertyBase &)> fun) override
| set new callback for update More...
const std::function< void(PropertyBase &)> | readCallBack () const override
| get a reference to the readCallBack More...
const std::function< void(PropertyBase &)> | updateCallBack () const override
| get a reference to the updateCallBack More...
void | useReadHandler () const
| use the call-back function at reading, if available More...
bool | useUpdateHandler () override
| use the call-back function at update, if available More...
Public Member Functions inherited from Gaudi::Details::PropertyBase
const std::string | name () const
| property name More...
std::string | documentation () const
| property documentation More...
const std::type_info * | type_info () const
| property type-info More...
std::string | type () const
| property type More...
virtual bool | load (PropertyBase &dest) const =0
| export the property value to the destination More...
virtual bool | assign (const PropertyBase &source)=0
| import the property value form the source More...
virtual PropertyBase & | declareReadHandler (std::function< void(PropertyBase &)> fun)=0
| set new callback for reading More...
virtual PropertyBase & | declareUpdateHandler (std::function< void(PropertyBase &)> fun)=0
| set new callback for update More...
template<class HT >
PropertyBase & | declareReadHandler (void(HT::*MF)(PropertyBase &), HT *instance)
template<class HT >
PropertyBase & | declareUpdateHandler (void(HT::*MF)(PropertyBase &), HT *instance)
virtual | ~PropertyBase ()=default
| virtual destructor More...
void | setName (std::string value)
| set the new value for the property name More...
void | setDocumentation (std::string value)
| set the documentation string More...
virtual std::ostream & | fillStream (std::ostream &) const
| the printout of the property value More...
void | setOwnerType (const std::type_info &ownerType)
| set the type of the owner class (used for documentation) More...
template<class OWNER >
void | setOwnerType ()
| set the type of the owner class (used for documentation) More...
const std::type_info * | ownerType () const
| get the type of the owner class (used for documentation) More...
std::string | ownerTypeName () const
| get the string for the type of the owner class (used for documentation) More...

## Private Attributes
std::unique_ptr< DataObjIDColl > | m_data

## Additional Inherited Members
Protected Member Functions inherited from Gaudi::Details::PropertyBase
| PropertyBase (const std::type_info &type, std::string name="", std::string doc="")
| constructor from the property name and the type More...
| PropertyBase (std::string name, const std::type_info &type)
| constructor from the property name and the type More...
| PropertyBase (const PropertyBase &)=default
| copy constructor More...
PropertyBase & | operator= (const PropertyBase &)=default
| assignment operator More...

## Detailed Description

### template<>
class Gaudi::Property< DataObjIDColl >

Definition at line 124 of file DataObjIDProperty.h.

## Constructor & Destructor Documentation

Gaudi::Property< DataObjIDColl >::Property | ( | const std::string & | name,
|  | DataObjIDColl & | value
| ) |  |
| inline

Definition at line 127 of file DataObjIDProperty.h.

127 : ::DataObjIDCollProperty( name, value ) {}
DataObjIDCollProperty::DataObjIDCollProperty
DataObjIDCollProperty(const std::string &name, DataObjIDColl &ref)
Definition: DataObjIDProperty.cpp:220
template<class OWNER >

Gaudi::Property< DataObjIDColl >::Property | ( | OWNER * | owner,
|  | const std::string & | name,
|  | const DataObjIDColl & | initval = `DataObjIDColl{}`,
|  | std::string | doc = `""`
| ) |  |
| inline

Autodeclaring constructor with property name, value and documentation.

{DataObjIDCollProperty is a ref property by construction and this is a temporary hack to have a "value" property}

Definition at line 131 of file DataObjIDProperty.h.

131 {},
132 std::string doc = "" )
133 : ::DataObjIDCollProperty( name, *( new DataObjIDColl{initval} ) )
134 {
137 m_data.reset( const_cast<DataObjIDColl*>( &value() ) );
138 setDocumentation( std::move( doc ) );
139 owner->declareProperty( *this );
140 setOwnerType<OWNER>();
141 }
Gaudi::Details::PropertyBase::setDocumentation
void setDocumentation(std::string value)
set the documentation string
Definition: Property.h:92
Gaudi::Property< DataObjIDColl >::m_data
std::unique_ptr< DataObjIDColl > m_data
Definition: DataObjIDProperty.h:149
std::string
STL class.
std::unordered_set< DataObjID, DataObjID_Hasher >
std::move
T move(T...args)
DataObjIDCollProperty::value
const DataObjIDColl & value() const
Definition: DataObjIDProperty.h:171
DataObjIDCollProperty::DataObjIDCollProperty
DataObjIDCollProperty(const std::string &name, DataObjIDColl &ref)
Definition: DataObjIDProperty.cpp:220

virtual Gaudi::Property< DataObjIDColl >::~Property | ( |  | ) |
| inline virtual

virtual Destructor

Definition at line 146 of file DataObjIDProperty.h.

146 {}

## Member Function Documentation

Gaudi::Property< DataObjIDColl >::operator const DataObjIDColl & | ( |  | ) | const
| inline

Definition at line 143 of file DataObjIDProperty.h.

143 { return value(); }
DataObjIDCollProperty::value
const DataObjIDColl & value() const
Definition: DataObjIDProperty.h:171

## Member Data Documentation

std::unique_ptr<DataObjIDColl> Gaudi::Property< DataObjIDColl >::m_data
| private

Definition at line 149 of file DataObjIDProperty.h.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/DataObjIDProperty.h